Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1789)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1791)
@@ -837,507 +891,507 @@
  CONTAINS
 
-
     SUBROUTINE pmci_map_fine_to_coarse_grid
 
-        IMPLICIT NONE
-
-        INTEGER(iwp), DIMENSION(5,numprocs)  ::  coarse_bound_all   !:
-        INTEGER(iwp), DIMENSION(2)           ::  size_of_array      !:
+       IMPLICIT NONE
+
+       INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all   !:
+       INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !:
                                               
-        REAL(wp)                             ::  coarse_dx   !:
-        REAL(wp)                             ::  coarse_dy   !:
-        REAL(wp)                             ::  loffset     !:
-        REAL(wp)                             ::  noffset     !:
-        REAL(wp)                             ::  roffset     !:
-        REAL(wp)                             ::  soffset     !:
-
-!
-!--     Determine indices of interpolation/anterpolation area in coarse grid.
-        coarse_dx = cg%dx
-        coarse_dy = cg%dy
-        
-        loffset = MOD( coord_x(nxl), coarse_dx )       !  If the fine- and coarse grid nodes do not match.
-        xexl    = coarse_dx + loffset
-        nhll    = CEILING( xexl / coarse_dx )          !  This is needed in the anterpolation phase.
-        xcs     = coord_x(nxl) - xexl
-        DO  i = 0, cg%nx
-           IF ( cg%coord_x(i) > xcs )  THEN
-              icl = MAX( -1, i-1 )  
-              EXIT
-           ENDIF
-        ENDDO
-
-        roffset = MOD( coord_x(nxr + 1), coarse_dx )   !  If the fine- and coarse grid nodes do not match.
-        xexr    = coarse_dx + roffset
-        nhlr    = CEILING( xexr / coarse_dx )          !  This is needed in the anterpolation phase.
-        xce     = coord_x(nxr) + xexr
-        DO  i = cg%nx, 0 , -1
-           IF ( cg%coord_x(i) < xce )  THEN
-              icr = MIN( cg%nx + 1, i + 1 )
-              EXIT
-           ENDIF
-        ENDDO
-
-        soffset = MOD( coord_y(nys), coarse_dy )       !  If the fine- and coarse grid nodes do not match
-        yexs    = coarse_dy + soffset
-        nhls    = CEILING( yexs / coarse_dy )          !  This is needed in the anterpolation phase.
-        ycs     = coord_y(nys) - yexs
-        DO  j = 0, cg%ny
-           IF ( cg%coord_y(j) > ycs )  THEN
-              jcs = MAX( -nbgp, j - 1 )  
-              EXIT
-           ENDIF
-        ENDDO
-
-        noffset = MOD( coord_y(nyn + 1), coarse_dy )   !  If the fine- and coarse grid nodes do not match
-        yexn    = coarse_dy + noffset
-        nhln    = CEILING( yexn / coarse_dy )          !  This is needed in the anterpolation phase.
-        yce     = coord_y(nyn) + yexn
-        DO  j = cg%ny, 0, -1
-           IF ( cg%coord_y(j) < yce )  THEN
-              jcn = MIN( cg%ny + nbgp, j + 1 )  
-              EXIT
-           ENDIF
-        ENDDO
-
-        coarse_bound(1) = icl
-        coarse_bound(2) = icr
-        coarse_bound(3) = jcs
-        coarse_bound(4) = jcn
-        coarse_bound(5) = myid
-!
-!--     Note that MPI_Gather receives data from all processes in the rank order. 
-        CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5, &
-                         MPI_INTEGER, 0, comm2d, ierr )
-
-        IF ( myid == 0 )  THEN
-           size_of_array(1) = SIZE( coarse_bound_all, 1 )
-           size_of_array(2) = SIZE( coarse_bound_all, 2 )
-           CALL pmc_send_to_server( size_of_array, 2, 0, 40, ierr )
-           CALL pmc_send_to_server( coarse_bound_all, SIZE( coarse_bound_all ), 0, 41, ierr )
-        ENDIF
-
-   END SUBROUTINE pmci_map_fine_to_coarse_grid
-
-
-
-   SUBROUTINE pmci_init_interp_tril
-
-!
-!--   Precomputation of the interpolation coefficients and client-array indices 
-!--   to be used by the interpolation routines interp_tril_lr, interp_tril_ns and 
-!--   interp_tril_t. Constant dz is still assumed.
-!
-!--                                  Antti Hellsten 3.3.2015.
-!
-!--   Modified for variable dz, but not yet tested.
-!--                                  Antti Hellsten 27.3.2015.
-!
-      IMPLICIT NONE
-
-      INTEGER(iwp) ::  i       !:
-      INTEGER(iwp) ::  i1      !:
-      INTEGER(iwp) ::  j       !:
-      INTEGER(iwp) ::  j1      !:
-      INTEGER(iwp) ::  k       !:
-      INTEGER(iwp) ::  kc      !:
-
-      REAL(wp) ::  coarse_dx   !:
-      REAL(wp) ::  coarse_dy   !:
-      REAL(wp) ::  coarse_dz   !:
-      REAL(wp) ::  xb          !:
-      REAL(wp) ::  xcsu        !:
-      REAL(wp) ::  xfso        !:
-      REAL(wp) ::  xcso        !:
-      REAL(wp) ::  xfsu        !:
-      REAL(wp) ::  yb          !:
-      REAL(wp) ::  ycso        !:
-      REAL(wp) ::  ycsv        !:
-      REAL(wp) ::  yfso        !:
-      REAL(wp) ::  yfsv        !:
-      REAL(wp) ::  zcso        !:
-      REAL(wp) ::  zcsw        !:
-      REAL(wp) ::  zfso        !:
-      REAL(wp) ::  zfsw        !:
+       REAL(wp) ::  loffset     !:
+       REAL(wp) ::  noffset     !:
+       REAL(wp) ::  roffset     !:
+       REAL(wp) ::  soffset     !:
+
+!
+!--    Determine indices of interpolation/anterpolation area in the coarse grid
+!--    If the fine- and coarse grid nodes do not match.
+       loffset = MOD( coord_x(nxl), cg%dx )
+       xexl    = cg%dx + loffset
+!
+!--    This is needed in the anterpolation phase
+       nhll = CEILING( xexl / cg%dx )
+       xcs  = coord_x(nxl) - xexl
+       DO  i = 0, cg%nx
+          IF ( cg%coord_x(i) > xcs )  THEN
+             icl = MAX( -1, i-1 )
+             EXIT
+          ENDIF
+       ENDDO
+!
+!--    If the fine- and coarse grid nodes do not match
+       roffset = MOD( coord_x(nxr+1), cg%dx )
+       xexr    = cg%dx + roffset
+!
+!--    This is needed in the anterpolation phase
+       nhlr = CEILING( xexr / cg%dx )
+       xce  = coord_x(nxr) + xexr
+       DO  i = cg%nx, 0 , -1
+          IF ( cg%coord_x(i) < xce )  THEN
+             icr = MIN( cg%nx+1, i+1 )
+             EXIT
+          ENDIF
+       ENDDO
+!
+!--    If the fine- and coarse grid nodes do not match
+       soffset = MOD( coord_y(nys), cg%dy )
+       yexs    = cg%dy + soffset
+!
+!--    This is needed in the anterpolation phase
+       nhls = CEILING( yexs / cg%dy )
+       ycs  = coord_y(nys) - yexs
+       DO  j = 0, cg%ny
+          IF ( cg%coord_y(j) > ycs )  THEN
+             jcs = MAX( -nbgp, j-1 )
+             EXIT
+          ENDIF
+       ENDDO
+!
+!--    If the fine- and coarse grid nodes do not match
+       noffset = MOD( coord_y(nyn+1), cg%dy )
+       yexn    = cg%dy + noffset
+!
+!--    This is needed in the anterpolation phase
+       nhln = CEILING( yexn / cg%dy )
+       yce  = coord_y(nyn) + yexn
+       DO  j = cg%ny, 0, -1
+          IF ( cg%coord_y(j) < yce )  THEN
+             jcn = MIN( cg%ny + nbgp, j+1 )
+             EXIT
+          ENDIF
+       ENDDO
+
+       coarse_bound(1) = icl
+       coarse_bound(2) = icr
+       coarse_bound(3) = jcs
+       coarse_bound(4) = jcn
+       coarse_bound(5) = myid
+!
+!--    Note that MPI_Gather receives data from all processes in the rank order
+!--    TO_DO: refer to the line where this fact becomes important
+       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5, &
+                        MPI_INTEGER, 0, comm2d, ierr )
+
+       IF ( myid == 0 )  THEN
+          size_of_array(1) = SIZE( coarse_bound_all, 1 )
+          size_of_array(2) = SIZE( coarse_bound_all, 2 )
+          CALL pmc_send_to_server( size_of_array, 2, 0, 40, ierr )
+          CALL pmc_send_to_server( coarse_bound_all, SIZE( coarse_bound_all ), &
+                                   0, 41, ierr )
+       ENDIF
+
+    END SUBROUTINE pmci_map_fine_to_coarse_grid
+
+
+
+    SUBROUTINE pmci_init_interp_tril
+!
+!--    Precomputation of the interpolation coefficients and client-array indices
+!--    to be used by the interpolation routines interp_tril_lr, interp_tril_ns
+!--    and interp_tril_t. Constant dz is still assumed.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i       !:
+       INTEGER(iwp) ::  i1      !:
+       INTEGER(iwp) ::  j       !:
+       INTEGER(iwp) ::  j1      !:
+       INTEGER(iwp) ::  k       !:
+       INTEGER(iwp) ::  kc      !:
+
+       REAL(wp) ::  xb          !:
+       REAL(wp) ::  xcsu        !:
+       REAL(wp) ::  xfso        !:
+       REAL(wp) ::  xcso        !:
+       REAL(wp) ::  xfsu        !:
+       REAL(wp) ::  yb          !:
+       REAL(wp) ::  ycso        !:
+       REAL(wp) ::  ycsv        !:
+       REAL(wp) ::  yfso        !:
+       REAL(wp) ::  yfsv        !:
+       REAL(wp) ::  zcso        !:
+       REAL(wp) ::  zcsw        !:
+       REAL(wp) ::  zfso        !:
+       REAL(wp) ::  zfsw        !:
       
 
-      coarse_dx = cg%dx
-      coarse_dy = cg%dy
-      coarse_dz = cg%dz
-      xb        = nxl * dx 
-      yb        = nys * dy
+       xb = nxl * dx
+       yb = nys * dy
       
-      ALLOCATE( icu(nxlg:nxrg) )
-      ALLOCATE( ico(nxlg:nxrg) )
-      ALLOCATE( jcv(nysg:nyng) )
-      ALLOCATE( jco(nysg:nyng) )
-      ALLOCATE( kcw(nzb:nzt+1) )
-      ALLOCATE( kco(nzb:nzt+1) )
-      ALLOCATE( r1xu(nxlg:nxrg) )
-      ALLOCATE( r2xu(nxlg:nxrg) )
-      ALLOCATE( r1xo(nxlg:nxrg) )
-      ALLOCATE( r2xo(nxlg:nxrg) )
-      ALLOCATE( r1yv(nysg:nyng) )
-      ALLOCATE( r2yv(nysg:nyng) )
-      ALLOCATE( r1yo(nysg:nyng) )
-      ALLOCATE( r2yo(nysg:nyng) )
-      ALLOCATE( r1zw(nzb:nzt+1) )
-      ALLOCATE( r2zw(nzb:nzt+1) )
-      ALLOCATE( r1zo(nzb:nzt+1) )
-      ALLOCATE( r2zo(nzb:nzt+1) )
-
-!
-!--   Note that the node coordinates xfs... and xcs... are relative 
-!--   to the lower-left-bottom corner of the fc-array, not the actual 
-!--   client domain corner.
-      DO  i = nxlg, nxrg
-         xfsu    = coord_x(i) - ( lower_left_coord_x + xb - xexl )
-         xfso    = coord_x(i) + 0.5_wp * dx - ( lower_left_coord_x + xb - xexl )
-         icu(i)  = icl + FLOOR( xfsu / coarse_dx )
-         ico(i)  = icl + FLOOR( ( xfso - 0.5_wp * coarse_dx ) / coarse_dx )
-         xcsu    = ( icu(i) - icl ) * coarse_dx 
-         xcso    = ( ico(i) - icl ) * coarse_dx + 0.5_wp * coarse_dx
-         r2xu(i) = ( xfsu - xcsu ) / coarse_dx
-         r2xo(i) = ( xfso - xcso ) / coarse_dx
-         r1xu(i) = 1.0_wp - r2xu(i)
-         r1xo(i) = 1.0_wp - r2xo(i)
-      ENDDO
-
-      DO  j = nysg, nyng
-         yfsv    = coord_y(j) - ( lower_left_coord_y + yb - yexs )
-         yfso    = coord_y(j) + 0.5_wp * dy - ( lower_left_coord_y + yb - yexs )
-         jcv(j)  = jcs + FLOOR( yfsv/coarse_dy )           
-         jco(j)  = jcs + FLOOR( ( yfso -0.5_wp * coarse_dy ) / coarse_dy )
-         ycsv    = ( jcv(j) - jcs ) * coarse_dy
-         ycso    = ( jco(j) - jcs ) * coarse_dy + 0.5_wp * coarse_dy         
-         r2yv(j) = ( yfsv - ycsv ) / coarse_dy            
-         r2yo(j) = ( yfso - ycso ) / coarse_dy  
-         r1yv(j) = 1.0_wp - r2yv(j)
-         r1yo(j) = 1.0_wp - r2yo(j)        
-      ENDDO
-
-      DO  k = nzb, nzt + 1
-         zfsw = zw(k)
-         zfso = zu(k)
-
-         kc = 0
-         DO  WHILE ( cg%zw(kc) <= zfsw ) 
-            kc = kc + 1
-         ENDDO
-         kcw(k) = kc - 1
+       ALLOCATE( icu(nxlg:nxrg) )
+       ALLOCATE( ico(nxlg:nxrg) )
+       ALLOCATE( jcv(nysg:nyng) )
+       ALLOCATE( jco(nysg:nyng) )
+       ALLOCATE( kcw(nzb:nzt+1) )
+       ALLOCATE( kco(nzb:nzt+1) )
+       ALLOCATE( r1xu(nxlg:nxrg) )
+       ALLOCATE( r2xu(nxlg:nxrg) )
+       ALLOCATE( r1xo(nxlg:nxrg) )
+       ALLOCATE( r2xo(nxlg:nxrg) )
+       ALLOCATE( r1yv(nysg:nyng) )
+       ALLOCATE( r2yv(nysg:nyng) )
+       ALLOCATE( r1yo(nysg:nyng) )
+       ALLOCATE( r2yo(nysg:nyng) )
+       ALLOCATE( r1zw(nzb:nzt+1) )
+       ALLOCATE( r2zw(nzb:nzt+1) )
+       ALLOCATE( r1zo(nzb:nzt+1) )
+       ALLOCATE( r2zo(nzb:nzt+1) )
+
+!
+!--    Note that the node coordinates xfs... and xcs... are relative to the
+!--    lower-left-bottom corner of the fc-array, not the actual client domain
+!--    corner
+       DO  i = nxlg, nxrg
+          xfsu    = coord_x(i) - ( lower_left_coord_x + xb - xexl )
+          xfso    = coord_x(i) + 0.5_wp * dx - ( lower_left_coord_x + xb - xexl )
+          icu(i)  = icl + FLOOR( xfsu / cg%dx )
+          ico(i)  = icl + FLOOR( ( xfso - 0.5_wp * cg%dx ) / cg%dx )
+          xcsu    = ( icu(i) - icl ) * cg%dx
+          xcso    = ( ico(i) - icl ) * cg%dx + 0.5_wp * cg%dx
+          r2xu(i) = ( xfsu - xcsu ) / cg%dx
+          r2xo(i) = ( xfso - xcso ) / cg%dx
+          r1xu(i) = 1.0_wp - r2xu(i)
+          r1xo(i) = 1.0_wp - r2xo(i)
+       ENDDO
+
+       DO  j = nysg, nyng
+          yfsv    = coord_y(j) - ( lower_left_coord_y + yb - yexs )
+          yfso    = coord_y(j) + 0.5_wp * dy - ( lower_left_coord_y + yb - yexs )
+          jcv(j)  = jcs + FLOOR( yfsv / cg%dy )
+          jco(j)  = jcs + FLOOR( ( yfso -0.5_wp * cg%dy ) / cg%dy )
+          ycsv    = ( jcv(j) - jcs ) * cg%dy
+          ycso    = ( jco(j) - jcs ) * cg%dy + 0.5_wp * cg%dy
+          r2yv(j) = ( yfsv - ycsv ) / cg%dy
+          r2yo(j) = ( yfso - ycso ) / cg%dy
+          r1yv(j) = 1.0_wp - r2yv(j)
+          r1yo(j) = 1.0_wp - r2yo(j)
+       ENDDO
+
+       DO  k = nzb, nzt + 1
+          zfsw = zw(k)
+          zfso = zu(k)
+
+          kc = 0
+          DO  WHILE ( cg%zw(kc) <= zfsw )
+             kc = kc + 1
+          ENDDO
+          kcw(k) = kc - 1
          
-         kc = 0
-         DO  WHILE ( cg%zu(kc) <= zfso ) 
-            kc = kc + 1
-         ENDDO
-         kco(k) = kc - 1
-
-         zcsw    = cg%zw(kcw(k))
-         zcso    = cg%zu(kco(k))
-         r2zw(k) = ( zfsw - zcsw ) / cg%dzw(kcw(k) + 1 )
-         r2zo(k) = ( zfso - zcso ) / cg%dzu(kco(k) + 1 )
-         r1zw(k) = 1.0_wp - r2zw(k)
-         r1zo(k) = 1.0_wp - r2zo(k)
-      ENDDO
+          kc = 0
+          DO  WHILE ( cg%zu(kc) <= zfso )
+             kc = kc + 1
+          ENDDO
+          kco(k) = kc - 1
+
+          zcsw    = cg%zw(kcw(k))
+          zcso    = cg%zu(kco(k))
+          r2zw(k) = ( zfsw - zcsw ) / cg%dzw(kcw(k)+1)
+          r2zo(k) = ( zfso - zcso ) / cg%dzu(kco(k)+1)
+          r1zw(k) = 1.0_wp - r2zw(k)
+          r1zo(k) = 1.0_wp - r2zo(k)
+       ENDDO
       
-   END SUBROUTINE pmci_init_interp_tril
-
-
-
-   SUBROUTINE pmci_init_loglaw_correction
-
-!
-!--   Precomputation of the index and log-ratio arrays for the log-law corrections
-!--   for near-wall nodes after the nest-BC interpolation.
-!--   These are used by the interpolation routines interp_tril_lr and interp_tril_ns.
-!
-!--                                  Antti Hellsten 30.12.2015.
-!
-      IMPLICIT NONE
-      INTEGER(iwp) ::  direction    !:  Wall normal index: 1=k, 2=j, 3=i.  
-      INTEGER(iwp) ::  i            !:
-      INTEGER(iwp) ::  icorr        !:
-      INTEGER(iwp) ::  inc          !:  Wall outward-normal index increment -1 or 1, for direction=1, inc=1 always. 
-      INTEGER(iwp) ::  iw           !:
-      INTEGER(iwp) ::  j            !:
-      INTEGER(iwp) ::  jcorr        !:
-      INTEGER(iwp) ::  jw           !:
-      INTEGER(iwp) ::  k            !:
-      INTEGER(iwp) ::  kb           !:
-      INTEGER(iwp) ::  kcorr        !:
-      INTEGER(iwp) ::  lc           !:
-      INTEGER(iwp) ::  ni           !:
-      INTEGER(iwp) ::  nj           !:
-      INTEGER(iwp) ::  nk           !:
-      INTEGER(iwp) ::  nzt_topo_max !:
-      INTEGER(iwp) ::  wall_index   !:  Index of the wall-node coordinate
-
-      REAL(wp), ALLOCATABLE, DIMENSION(:) ::  lcr   !:
-
-!
-!--   First determine the maximum k-index needed for the near-wall corrections.
-!--   This maximum is individual for each boundary to minimize the storage requirements
-!--   and to minimize the corresponding loop k-range in the interpolation routines.
-      nzt_topo_nestbc_l = nzb
-      IF ( nest_bound_l )  THEN
-         DO  i = nxl - 1, nxl
-            DO  j = nys, nyn
-               nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i),   &
-                                        nzb_v_inner(j,i), nzb_w_inner(j,i) )
-            ENDDO
-         ENDDO
-         nzt_topo_nestbc_l = nzt_topo_nestbc_l + 1
-      ENDIF
+    END SUBROUTINE pmci_init_interp_tril
+
+
+
+    SUBROUTINE pmci_init_loglaw_correction
+!
+!--    Precomputation of the index and log-ratio arrays for the log-law
+!--    corrections for near-wall nodes after the nest-BC interpolation.
+!--    These are used by the interpolation routines interp_tril_lr and
+!--    interp_tril_ns.
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  direction    !:  Wall normal index: 1=k, 2=j, 3=i.
+       INTEGER(iwp) ::  i            !:
+       INTEGER(iwp) ::  icorr        !:
+       INTEGER(iwp) ::  inc          !:  Wall outward-normal index increment -1
+                                     !: or 1, for direction=1, inc=1 always
+       INTEGER(iwp) ::  iw           !:
+       INTEGER(iwp) ::  j            !:
+       INTEGER(iwp) ::  jcorr        !:
+       INTEGER(iwp) ::  jw           !:
+       INTEGER(iwp) ::  k            !:
+       INTEGER(iwp) ::  kb           !:
+       INTEGER(iwp) ::  kcorr        !:
+       INTEGER(iwp) ::  lc           !:
+       INTEGER(iwp) ::  ni           !:
+       INTEGER(iwp) ::  nj           !:
+       INTEGER(iwp) ::  nk           !:
+       INTEGER(iwp) ::  nzt_topo_max !:
+       INTEGER(iwp) ::  wall_index   !:  Index of the wall-node coordinate
+
+       REAL(wp), ALLOCATABLE, DIMENSION(:) ::  lcr   !:
+
+!
+!--    First determine the maximum k-index needed for the near-wall corrections.
+!--    This maximum is individual for each boundary to minimize the storage
+!--    requirements and to minimize the corresponding loop k-range in the
+!--    interpolation routines.
+       nzt_topo_nestbc_l = nzb
+       IF ( nest_bound_l )  THEN
+          DO  i = nxl-1, nxl
+             DO  j = nys, nyn
+                nzt_topo_nestbc_l = MAX( nzt_topo_nestbc_l, nzb_u_inner(j,i),  &
+                                         nzb_v_inner(j,i), nzb_w_inner(j,i) )
+             ENDDO
+          ENDDO
+          nzt_topo_nestbc_l = nzt_topo_nestbc_l + 1
+       ENDIF
       
-      nzt_topo_nestbc_r = nzb
-      IF ( nest_bound_r )  THEN
-         i = nxr + 1
-         DO  j = nys, nyn
-            nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i),      &
-                                     nzb_v_inner(j,i), nzb_w_inner(j,i) )
-         ENDDO
-         nzt_topo_nestbc_r = nzt_topo_nestbc_r + 1       
-      ENDIF
-
-      nzt_topo_nestbc_s = nzb
-      IF ( nest_bound_s )  THEN
-         DO  j = nys - 1, nys
-            DO  i = nxl, nxr
-               nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i),   &
-                                        nzb_v_inner(j,i), nzb_w_inner(j,i) )
-            ENDDO
-         ENDDO
-         nzt_topo_nestbc_s = nzt_topo_nestbc_s + 1      
-      ENDIF
-
-      nzt_topo_nestbc_n = nzb
-      IF ( nest_bound_n )  THEN
-         j = nyn + 1
-         DO  i = nxl, nxr
-            nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i),      &
-                                     nzb_v_inner(j,i), nzb_w_inner(j,i) )
-         ENDDO
-         nzt_topo_nestbc_n = nzt_topo_nestbc_n + 1
-      ENDIF
-
-!
-!--   Then determine the maximum number of near-wall nodes per wall point based
-!--   on the grid-spacing ratios.
-      nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r,                &
-                          nzt_topo_nestbc_s, nzt_topo_nestbc_n )
-
-!
-!--   Note that the outer division must be integer division.
-      ni = CEILING( cg%dx / dx ) / 2
-      nj = CEILING( cg%dy / dy ) / 2
-      nk = 1
-      DO  k = 1, nzt_topo_max
-         nk = MAX( nk, CEILING( cg%dzu(k) / dzu(k) ) )
-      ENDDO
-      nk = nk / 2   !  Note that this must be integer division.
-      ncorr =  MAX( ni, nj, nk )
-
-      ALLOCATE( lcr(0:ncorr - 1) )
-      lcr = 1.0_wp
-
-!
-!--   First horizontal walls
-!--   Left boundary
-      IF ( nest_bound_l )   THEN
-         ALLOCATE( logc_u_l(nzb:nzt_topo_nestbc_l, nys:nyn, 1:2) )
-         ALLOCATE( logc_v_l(nzb:nzt_topo_nestbc_l, nys:nyn, 1:2) )
-         ALLOCATE( logc_ratio_u_l(nzb:nzt_topo_nestbc_l, nys:nyn, 1:2, 0:ncorr-1) )
-         ALLOCATE( logc_ratio_v_l(nzb:nzt_topo_nestbc_l, nys:nyn, 1:2, 0:ncorr-1) )
-         logc_u_l       = 0
-         logc_v_l       = 0
-         logc_ratio_u_l = 1.0_wp
-         logc_ratio_v_l = 1.0_wp
-         direction      = 1
-         inc            = 1
-
-         DO  j = nys, nyn      
-!
-!--         Left boundary for u
-            i   = 0
-            kb  = nzb_u_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_u_l(k,j,1) = lc
-            logc_ratio_u_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--         Left boundary for v
-            i   = -1
-            kb  =  nzb_v_inner(j,i)
-            k   =  kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_v_l(k,j,1) = lc
-            logc_ratio_v_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-         ENDDO
-      ENDIF
-
-!
-!--   Right boundary
-      IF ( nest_bound_r )  THEN
-         ALLOCATE( logc_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
-         ALLOCATE( logc_v_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
-         ALLOCATE( logc_ratio_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,0:ncorr-1) )
-         ALLOCATE( logc_ratio_v_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,0:ncorr-1) )
-         logc_u_r       = 0
-         logc_v_r       = 0
-         logc_ratio_u_r = 1.0_wp
-         logc_ratio_v_r = 1.0_wp
-         direction      = 1
-         inc            = 1  
-         DO  j = nys, nyn
-!
-!--         Right boundary for u.
-            i   = nxr + 1
-            kb  = nzb_u_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_u_r(k,j,1) = lc
-            logc_ratio_u_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--         Right boundary for v.
-            i   = nxr + 1
-            kb  = nzb_v_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_v_r(k,j,1) = lc
-            logc_ratio_v_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-         ENDDO
-      ENDIF
-
-!
-!--   South boundary
-      IF ( nest_bound_s )  THEN
-         ALLOCATE( logc_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
-         ALLOCATE( logc_v_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
-         ALLOCATE( logc_ratio_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2,0:ncorr-1) )
-         ALLOCATE( logc_ratio_v_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2,0:ncorr-1) )
-         logc_u_s       = 0
-         logc_v_s       = 0
-         logc_ratio_u_s = 1.0_wp
-         logc_ratio_v_s = 1.0_wp
-         direction      = 1
-         inc            = 1 
-         DO  i = nxl, nxr
-!
-!--         South boundary for u.
-            j   = -1
-            kb  =  nzb_u_inner(j,i)
-            k   =  kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_u_s(k,i,1) = lc
-            logc_ratio_u_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--         South boundary for v
-            j   = 0
-            kb  = nzb_v_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_v_s(k,i,1) = lc
-            logc_ratio_v_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-         ENDDO
-      ENDIF
-
-!
-!--   North boundary
-      IF ( nest_bound_n )  THEN
-         ALLOCATE( logc_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
-         ALLOCATE( logc_v_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
-         ALLOCATE( logc_ratio_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2,0:ncorr-1) )
-         ALLOCATE( logc_ratio_v_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2,0:ncorr-1) )
-         logc_u_n       = 0
-         logc_v_n       = 0
-         logc_ratio_u_n = 1.0_wp
-         logc_ratio_v_n = 1.0_wp 
-         direction      = 1
-         inc            = 1 
-         DO  i = nxl, nxr
-!
-!--         North boundary for u.
-            j   = nyn + 1
-            kb  = nzb_u_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_u_n(k,i,1) = lc
-            logc_ratio_u_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-!
-!--         North boundary for v.
-            j   = nyn + 1
-            kb  = nzb_v_inner(j,i)
-            k   = kb + 1
-            wall_index = kb 
-            CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, &
-                                     wall_index, z0(j,i), kb, direction, ncorr )
-            logc_v_n(k,i,1) = lc
-            logc_ratio_v_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
-            lcr(0:ncorr-1) = 1.0_wp
-
-         ENDDO
-      ENDIF
+       nzt_topo_nestbc_r = nzb
+       IF ( nest_bound_r )  THEN
+          i = nxr + 1
+          DO  j = nys, nyn
+             nzt_topo_nestbc_r = MAX( nzt_topo_nestbc_r, nzb_u_inner(j,i),     &
+                                      nzb_v_inner(j,i), nzb_w_inner(j,i) )
+          ENDDO
+          nzt_topo_nestbc_r = nzt_topo_nestbc_r + 1
+       ENDIF
+
+       nzt_topo_nestbc_s = nzb
+       IF ( nest_bound_s )  THEN
+          DO  j = nys-1, nys
+             DO  i = nxl, nxr
+                nzt_topo_nestbc_s = MAX( nzt_topo_nestbc_s, nzb_u_inner(j,i),  &
+                                         nzb_v_inner(j,i), nzb_w_inner(j,i) )
+             ENDDO
+          ENDDO
+          nzt_topo_nestbc_s = nzt_topo_nestbc_s + 1
+       ENDIF
+
+       nzt_topo_nestbc_n = nzb
+       IF ( nest_bound_n )  THEN
+          j = nyn + 1
+          DO  i = nxl, nxr
+             nzt_topo_nestbc_n = MAX( nzt_topo_nestbc_n, nzb_u_inner(j,i),     &
+                                      nzb_v_inner(j,i), nzb_w_inner(j,i) )
+          ENDDO
+          nzt_topo_nestbc_n = nzt_topo_nestbc_n + 1
+       ENDIF
+
+!
+!--    Then determine the maximum number of near-wall nodes per wall point based
+!--    on the grid-spacing ratios.
+       nzt_topo_max = MAX( nzt_topo_nestbc_l, nzt_topo_nestbc_r,               &
+                           nzt_topo_nestbc_s, nzt_topo_nestbc_n )
+
+!
+!--    Note that the outer division must be integer division.
+       ni = CEILING( cg%dx / dx ) / 2
+       nj = CEILING( cg%dy / dy ) / 2
+       nk = 1
+       DO  k = 1, nzt_topo_max
+          nk = MAX( nk, CEILING( cg%dzu(k) / dzu(k) ) )
+       ENDDO
+       nk = nk / 2   !  Note that this must be integer division.
+       ncorr =  MAX( ni, nj, nk )
+
+       ALLOCATE( lcr(0:ncorr-1) )
+       lcr = 1.0_wp
+
+!
+!--    First horizontal walls
+!--    Left boundary
+       IF ( nest_bound_l )  THEN
+          ALLOCATE( logc_u_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
+          ALLOCATE( logc_v_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
+          ALLOCATE( logc_ratio_u_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2,0:ncorr-1) )
+          ALLOCATE( logc_ratio_v_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2,0:ncorr-1) )
+          logc_u_l       = 0
+          logc_v_l       = 0
+          logc_ratio_u_l = 1.0_wp
+          logc_ratio_v_l = 1.0_wp
+          direction      = 1
+          inc            = 1
+
+          DO  j = nys, nyn
+!
+!--          Left boundary for u
+             i   = 0
+             kb  = nzb_u_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_u_l(k,j,1) = lc
+             logc_ratio_u_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+!
+!--          Left boundary for v
+             i   = -1
+             kb  =  nzb_v_inner(j,i)
+             k   =  kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_v_l(k,j,1) = lc
+             logc_ratio_v_l(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+          ENDDO
+       ENDIF
+
+!
+!--    Right boundary
+       IF ( nest_bound_r )  THEN
+          ALLOCATE( logc_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
+          ALLOCATE( logc_v_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
+          ALLOCATE( logc_ratio_u_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,0:ncorr-1) )
+          ALLOCATE( logc_ratio_v_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,0:ncorr-1) )
+          logc_u_r       = 0
+          logc_v_r       = 0
+          logc_ratio_u_r = 1.0_wp
+          logc_ratio_v_r = 1.0_wp
+          direction      = 1
+          inc            = 1
+          DO  j = nys, nyn
+!
+!--          Right boundary for u.
+             i   = nxr + 1
+             kb  = nzb_u_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_u_r(k,j,1) = lc
+             logc_ratio_u_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+!
+!--          Right boundary for v.
+             i   = nxr + 1
+             kb  = nzb_v_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_v_r(k,j,1) = lc
+             logc_ratio_v_r(k,j,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+          ENDDO
+       ENDIF
+
+!
+!--    South boundary
+       IF ( nest_bound_s )  THEN
+          ALLOCATE( logc_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
+          ALLOCATE( logc_v_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2) )
+          ALLOCATE( logc_ratio_u_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2,0:ncorr-1) )
+          ALLOCATE( logc_ratio_v_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2,0:ncorr-1) )
+          logc_u_s       = 0
+          logc_v_s       = 0
+          logc_ratio_u_s = 1.0_wp
+          logc_ratio_v_s = 1.0_wp
+          direction      = 1
+          inc            = 1
+          DO  i = nxl, nxr
+!
+!--          South boundary for u.
+             j   = -1
+             kb  =  nzb_u_inner(j,i)
+             k   =  kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_u_s(k,i,1) = lc
+             logc_ratio_u_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+!
+!--          South boundary for v
+             j   = 0
+             kb  = nzb_v_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_v_s(k,i,1) = lc
+             logc_ratio_v_s(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+          ENDDO
+       ENDIF
+
+!
+!--    North boundary
+       IF ( nest_bound_n )  THEN
+          ALLOCATE( logc_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
+          ALLOCATE( logc_v_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2) )
+          ALLOCATE( logc_ratio_u_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2,0:ncorr-1) )
+          ALLOCATE( logc_ratio_v_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2,0:ncorr-1) )
+          logc_u_n       = 0
+          logc_v_n       = 0
+          logc_ratio_u_n = 1.0_wp
+          logc_ratio_v_n = 1.0_wp
+          direction      = 1
+          inc            = 1
+          DO  i = nxl, nxr
+!
+!--          North boundary for u.
+             j   = nyn + 1
+             kb  = nzb_u_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_u_n(k,i,1) = lc
+             logc_ratio_u_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+!
+!--          North boundary for v.
+             j   = nyn + 1
+             kb  = nzb_v_inner(j,i)
+             k   = kb + 1
+             wall_index = kb
+             CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j,     &
+                                inc, wall_index, z0(j,i), kb, direction, ncorr )
+             logc_v_n(k,i,1) = lc
+             logc_ratio_v_n(k,i,1,0:ncorr-1) = lcr(0:ncorr-1)
+             lcr(0:ncorr-1) = 1.0_wp
+
+          ENDDO
+       ENDIF
 
 !       
-!--   Then vertical walls and corners if necessary.
-      IF ( topography /= 'flat' ) THEN        
-         kb = 0       ! kb is not used when direction > 1
+!--    Then vertical walls and corners if necessary.
+       IF ( topography /= 'flat' )  THEN
+          kb = 0       ! kb is not used when direction > 1
 !        
-!--      Left boundary
-         IF ( nest_bound_l )  THEN
-            ALLOCATE( logc_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
-            ALLOCATE( logc_ratio_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2,0:ncorr-1) )
-            logc_w_l       = 0                   
-            logc_ratio_w_l = 1.0_wp
-            direction      = 2
-            DO  j = nys, nyn
-               DO  k = nzb, nzt_topo_nestbc_l
-
-!
-!--               Wall for u on the south side, but not on the north side.
-                  i  = 0
-                  IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) ) .AND.     &
-                       ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )  THEN
-                     inc        =  1
-                     wall_index =  j 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_u_l(k,j,2) = inc * lc
-                     logc_ratio_u_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for u on the north side, but not on the south side.
-                  i  = 0
+!--       Left boundary
+          IF ( nest_bound_l )  THEN
+             ALLOCATE( logc_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2) )
+             ALLOCATE( logc_ratio_w_l(nzb:nzt_topo_nestbc_l,nys:nyn,1:2,       &
+                                      0:ncorr-1) )
+             logc_w_l       = 0
+             logc_ratio_w_l = 1.0_wp
+             direction      = 2
+             DO  j = nys, nyn
+                DO  k = nzb, nzt_topo_nestbc_l
+
+!
+!--                Wall for u on the south side, but not on the north side
+                   i  = 0
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) ) .AND.        &
+                        ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )           &
+                   THEN
+                      inc        =  1
+                      wall_index =  j
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_u_l(k,j,2) = inc * lc
+                      logc_ratio_u_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+!
+!--                Wall for u on the north side, but not on the south side
+                   i  = 0
+!--                TO_DO: routine must be indentet by 1 space from here on,
+!--                       and long lines must be wrapped
                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) ) .AND.     &
                        ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
